#include <conio.h>  /* _getch, ... */
#include <stdio.h>  /* SEEK_SET, ... */
#include <io.h>     /* _open, _read, _fseek, _close, ...*/
#include <fcntl.h>  /* _O_RDONLY, ... */
#include <graph.h>  /* _setvideomoderows, ... */
#include <memory.h>
#include <malloc.h>
#include <dos.h>
#include <string.h>
#include <process.h>
#include <direct.h> /* _chdir */
#include "TYPES.H"
#include "MPC.H"

int CONFileHandle;
BYTE CONFileName[FILENAME_SIZE];
BYTE WARNINGFileName[FILENAME_SIZE];
BYTE BCKFileName[FILENAME_SIZE];
BYTE WINFileName[FILENAME_SIZE];
BYTE ABOUTFileName[FILENAME_SIZE];
BYTE INTROFileName[FILENAME_SIZE];
WORD *pWINData, *pABOUTData;

/***************************************************************************/

void BlinkOff ()
{
  union _REGS InRegs, OutRegs;

  InRegs.h.ah = 0x10;
  InRegs.h.al = 0x03;
  InRegs.h.bl = 0x00;
  _int86 (0x10, &InRegs, &OutRegs);

  return;
}

/***************************************************************************/

void BlinkOn ()
{
  union _REGS InRegs, OutRegs;

  InRegs.h.ah = 0x10;
  InRegs.h.al = 0x03;
  InRegs.h.bl = 0x01;
  _int86 (0x10, &InRegs, &OutRegs);

  return;
}

/***************************************************************************/

void HideCursor ()
{
  union _REGS InRegs, OutRegs;

  InRegs.h.ah = 0x01;
  InRegs.h.ch = 0x20;
  _int86 (0x10, &InRegs, &OutRegs);

  return;
}

/***************************************************************************/

void ShowCursor ()
{
  union _REGS InRegs, OutRegs;

  InRegs.h.ah = 0x01;
  InRegs.x.cx = 0x0607;
  _int86 (0x10, &InRegs, &OutRegs);

  return;
}

/***************************************************************************/

void InitMouse (WORD DX, WORD DY)
{
  union _REGS InRegs, OutRegs;

  InRegs.x.ax = 0x0000;
  _int86 (0x33, &InRegs, &OutRegs);
  InRegs.x.ax = 0x0007;
  InRegs.x.cx = 0x0000;
  InRegs.x.dx = DX - 1;
  _int86 (0x33, &InRegs, &OutRegs);
  InRegs.x.ax = 0x0008;
  InRegs.x.cx = 0x0000;
  InRegs.x.dx = DY - 1;
  _int86 (0x33, &InRegs, &OutRegs);

  return;
}

/***************************************************************************/

void ShowMouse ()
{
  union _REGS InRegs, OutRegs;

  InRegs.x.ax = 0x0001;
  _int86 (0x33, &InRegs, &OutRegs);

  return;
}

/***************************************************************************/

void HideMouse ()
{
  union _REGS InRegs, OutRegs;

  InRegs.x.ax = 0x0002;
  _int86 (0x33, &InRegs, &OutRegs);

  return;
}

/***************************************************************************/

void PutMouse (WORD X, WORD Y)
{
  union _REGS InRegs, OutRegs;

  InRegs.x.ax = 0x0004;
  InRegs.x.cx = X;
  InRegs.x.dx = Y;
  _int86 (0x33, &InRegs, &OutRegs);

  return;
}

/***************************************************************************/

WORD GetMouseX ()
{
  union _REGS InRegs, OutRegs;

  InRegs.x.ax = 0x0003;
  _int86 (0x33, &InRegs, &OutRegs);

  return (OutRegs.x.cx);
}

/***************************************************************************/

WORD GetMouseY ()
{
  union _REGS InRegs, OutRegs;

  InRegs.x.ax = 0x0003;
  _int86 (0x33, &InRegs, &OutRegs);

  return (OutRegs.x.dx);
}

/***************************************************************************/

BOOL LeftClick ()
{
  union _REGS InRegs, OutRegs;

  InRegs.x.ax = 0x0003;
  _int86 (0x33, &InRegs, &OutRegs);
  if (OutRegs.x.bx == 0x0001)
    return (TRUE);

  return (FALSE);
}

/***************************************************************************/

BOOL RightClick ()
{
  union _REGS InRegs, OutRegs;

  InRegs.x.ax = 0x0003;
  _int86 (0x33, &InRegs, &OutRegs);
  if (OutRegs.x.bx == 0x0002)
     return (TRUE);

  return (FALSE);
}

/****************************************************************************/

void WriteBlockFile (int Handle, long Offset, unsigned EOT, WORD X, WORD Y, WORD DX, WORD DY, WORD Col, WORD CHR)
{
  /* Print text (cf WriteBlockText) from file whose handle is Handle starting from
     offset Offset until BYTE EOT is meet */

  WORD __huge *pScreen, __huge *pLine;
  BOOL Text;
  BYTE C;

  lseek (Handle, Offset, SEEK_SET);
  Text = TRUE;
  pScreen = 0xB8000000 + (((Y*SCREEN_DX) + X) << 1);
  read (Handle, &C, 1);
  while (DY != 0)
  {
    /* Read/write a line */

    pLine = pScreen;
    for (X = DX; X != 0; X --)
    {
      if (Text == TRUE)
      {
	if (C == '\n')
	{
	  while (X != 0)
	  {
	    *pLine ++ = Col | CHR;
	    X --;
	  }
	  read (Handle, &C, 1);
	  goto NextLine;
	}
	if (C == EOT)
	{
	  *pLine ++ = Col | CHR;
	  Text = FALSE;
	}
	else
	{
	  *pLine ++ = Col | C;
	  read (Handle, &C, 1);
	}
      }
      else
	*pLine ++ = Col | CHR;
    }

    /* Skip next BYTE if '\n' ending a full width line */

    if (Text == TRUE)
    {
      if (C == '\n')
	read (Handle, &C, 1);
    }
NextLine:
    pScreen += SCREEN_DX;
    DY --;
  }
}

/****************************************************************************/

void WriteBlockText (BYTE *pString, WORD X, WORD Y, WORD DX, WORD DY, WORD Col, WORD CHR)
{
  /* Write the string pointed by pString in the zone (X, Y, DX, DY) using
     text/background colors set as Col. Fill the zone with BYTE CHR if
     zone is not fully filled by the string. If pString == NULL, the zone
     is just cleared */

  WORD __huge *pScreen, __huge *pLine;
  BOOL Text;

  if ((pString == NULL) || (*pString == '\0'))
    Text = FALSE;
  else
    Text = TRUE;
  pScreen = 0xB8000000 + ((Y*SCREEN_DX + X) << 1);
  while (DY != 0)
  {
    /* Write a line */

    pLine = pScreen;
    for (X = DX; X != 0; X --)
    {
      if (Text == TRUE)
      {
	switch (*pString)
	{
	  case '\n':
	    while (X != 0)
	    {
	      *pLine ++ = Col | CHR;
	      X --;
	    }
	    goto NextLine;

	  case '\0':
	    *pLine ++ = Col | CHR;
	    Text = FALSE;
	    break;

	  default:
	    *pLine ++ = Col | *pString ++;
	    break;
	}
      }
      else
      *pLine ++ = Col | CHR;
    }

    /* Skip next BYTE if '\n' ending a full width line */

    if (Text == TRUE)
    {
      if (*pString == '\n')
	pString ++;
    }
NextLine:
    pScreen += SCREEN_DX;
    DY --;
  }

  return;
}

/****************************************************************************/

struct TList *CONSetup (void)
{
  /* Acces to resource CON file and create the equivalent TList/TNode
     structures set. File is *NOT* closed at the end of this call.
     '\n' is considered $0D0A */

  struct TNodePARENT *pNodePARENT;
  struct TNodeLIST *pNodeLIST;
  struct TNodeNODE *pNodeNODE;
  struct TNodePICTURE *pNodePICTURE;
  struct TNode *pNode;
  long L;
  struct TList *pListTmp, *pList;
  BYTE C, *pString;
  WORD EndNode, EndList, Size;

  /* Initializations */

  CONFileHandle = _open (CONFileName, _O_RDONLY);
  pList = malloc (sizeof (struct TList));
  pList->Head = NULL;
  pList->Pred = NULL;
  pNode = NULL;

  /* Decrypt loop */

  for (;;)
  {
    do
      read (CONFileHandle, &C, 1);
    while (C != '[');
    read (CONFileHandle, &L, 4);
    switch (L)
    {
      case TAG_PICT:
	lseek (CONFileHandle, 3, SEEK_CUR);
	if (pList->Head != NULL)
	{
	  pNodePICTURE = malloc (sizeof (struct TNodePICTURE));
	  pNode->Succ = (struct TNode *) pNodePICTURE;
	  pNodePICTURE->Node.Pred = pNode;
	}
	else
	{
	  pNodePICTURE = malloc (sizeof (struct TNodePICTURE));
	  pNodePICTURE->Node.Pred = NULL;
	  pList->Head = &(pNodePICTURE->Node);
	}
	pNodePICTURE->Node.Succ = NULL;
	pNodePICTURE->Node.Type = TYPE_PICTURE;
	pNodePICTURE->OfsLDes = - 1;
	pNodePICTURE->OfsSDes = - 1;
	pNodePICTURE->pFileName = NULL;
	EndNode = FALSE;
	while (EndNode == FALSE)
	{
	  do
	    read (CONFileHandle, &C, 1);
	  while (C != '<');
	  read (CONFileHandle, &L, 4);
	  switch (L)
	  {
	    case TAG_NAME:
	      lseek (CONFileHandle, 3, SEEK_CUR);
	      pNodePICTURE->Node.pName = malloc (NAME_SIZE);
	      pString = pNodePICTURE->Node.pName;
	      read (CONFileHandle, &C, 1);
	      for (Size = NAME_SIZE; Size > 1; Size --)
	      {
		if (C == '\n')
		  break;
		*pString ++ = C;
		read (CONFileHandle, &C, 1);
	      }
	      *pString = '\0';
	      break;

	    case TAG_SDES:
	      lseek (CONFileHandle, 3, SEEK_CUR);
	      pNodePICTURE->OfsSDes = _tell (CONFileHandle);
	      break;

	    case TAG_LDES:
	      lseek (CONFileHandle, 3, SEEK_CUR);
	      pNodePICTURE->OfsLDes = _tell (CONFileHandle);
	      break;

	    case TAG_FILE:
	      lseek (CONFileHandle, 3, SEEK_CUR);
	      pNodePICTURE->pFileName = malloc (FILENAME_SIZE);
	      pString = pNodePICTURE->pFileName;
	      read (CONFileHandle, &C, 1);
	      for (Size = FILENAME_SIZE; Size > 1; Size --)
	      {
		if (C == '\n')
		  break;
		*pString ++ = C;
		read (CONFileHandle, &C, 1);
	      }
	      *pString = '\0';
	      break;

	    case TAG_DONE:
	      lseek (CONFileHandle, 3, SEEK_CUR);
	      EndNode = TRUE;
	      break;

	    default:
/* Should report error and freem all allocated memory */
	      break;
	  }
	  pNode = &(pNodePICTURE->Node);
	}
	break;

      case TAG_NODE:
	lseek (CONFileHandle, 3, SEEK_CUR);
	if (pList->Head != NULL)
	{
	  pNodeNODE = malloc (sizeof (struct TNodeNODE));
	  pNode->Succ = (struct TNode *) pNodeNODE;
	  pNodeNODE->Node.Pred = pNode;
	}
	else
	{
	  pNodeNODE =  malloc (sizeof (struct TNodeNODE));
	  pNodeNODE->Node.Pred = NULL;
	  pList->Head = &(pNodeNODE->Node);
	}
	pNodeNODE->Node.Succ = NULL;
	pNodeNODE->Node.Type = TYPE_NODE;
	pNodeNODE->OfsLDes = - 1;
	pNodeNODE->OfsSDes = - 1;
	pNodeNODE->OfsCMDS = - 1;
	EndNode = FALSE;
	while (EndNode == FALSE)
	{
	  do
	    read (CONFileHandle, &C, 1);
	  while (C != '<');
	  read (CONFileHandle, &L, 4);
	  switch (L)
	  {
	    case TAG_NAME:
	      lseek (CONFileHandle, 3, SEEK_CUR);
	      pNodeNODE->Node.pName = malloc (NAME_SIZE);
	      pString = pNodeNODE->Node.pName;
	      read (CONFileHandle, &C, 1);
	      for (Size = NAME_SIZE; Size > 1; Size --)
	      {
		if (C == '\n')
		  break;
		*pString ++ = C;
		read (CONFileHandle, &C, 1);
	      }
	      *pString = '\0';
	      break;

	    case TAG_SDES:
	      lseek (CONFileHandle, 3, SEEK_CUR);
	      pNodeNODE->OfsSDes = _tell (CONFileHandle);
	      break;

	    case TAG_LDES:
	      lseek (CONFileHandle, 3, SEEK_CUR);
	      pNodeNODE->OfsLDes = _tell (CONFileHandle);
	      break;

	    case TAG_CMDS:
	      lseek (CONFileHandle, 3, SEEK_CUR);
	      pNodeNODE->OfsCMDS = _tell (CONFileHandle);
	      break;

	    case TAG_DONE:
	      lseek (CONFileHandle, 3, SEEK_CUR);
	      EndNode = TRUE;
	      break;

	    default:
/* Should report error and freem all allocated memory */
	      break;
	  }
	  pNode = &(pNodeNODE->Node);
	}
	break;

      case TAG_LIST:
	lseek (CONFileHandle, 3, SEEK_CUR);
	if (pList->Head != NULL)
	{
	  pNodeLIST = malloc (sizeof (struct TNodeLIST));
	  pNode->Succ = (struct TNode *) pNodeLIST;
	  pNodeLIST->Node.Pred = pNode;
	}
	else
	{
	  pNodeLIST = malloc (sizeof (struct TNodeLIST));
	  pNodeLIST->Node.Pred = NULL;
	  pList->Head = &(pNodeLIST->Node);
	}
	pNodeLIST->Node.Succ = NULL;
	pNodeLIST->Node.Type = TYPE_LIST;
	pNodeLIST->OfsLDes = - 1;
	pNodeLIST->OfsSDes = - 1;
	EndList = FALSE;
	while (EndList == FALSE)
	{
	  do
	    read (CONFileHandle, &C, 1);
	  while (C !='<');
	  read (CONFileHandle, &L, 4);
	  switch (L)
	  {
	    case TAG_NAME:
	      lseek (CONFileHandle, 3, SEEK_CUR);
	      pNodeLIST->Node.pName = malloc (NAME_SIZE);
	      pString = pNodeLIST->Node.pName;
	      read (CONFileHandle, &C, 1);
	      for (Size = NAME_SIZE; Size > 1; Size --)
	      {
		if (C == '\n')
		  break;
		*pString ++ = C;
		read (CONFileHandle, &C, 1);
	      }
	      *pString = '\0';
	      break;

	    case TAG_SDES:
	      lseek (CONFileHandle, 3, SEEK_CUR);
	      pNodeLIST->OfsSDes = _tell (CONFileHandle);
	      break;

	    case TAG_LDES:
	      lseek (CONFileHandle, 3, SEEK_CUR);
	      pNodeLIST->OfsLDes = _tell (CONFileHandle);
	      break;

	    case TAG_LIST:
	      lseek (CONFileHandle, 3, SEEK_CUR);
	      EndList = TRUE;
	      break;

	    default:
/* Should report error and freem all allocated memory */
	      break;
	  }
	}

	/* Create a new list in the list of lists */

	pListTmp = malloc (sizeof (struct TList));
	pListTmp->Pred = pList;
	pList = pListTmp;
	pNodeLIST->pList = pList;

	/* Create the first node of the list as a TNodePARENT structure */

	pNodePARENT = malloc (sizeof (struct TNodePARENT));
	pNodePARENT->Node.Succ = NULL;
	pNodePARENT->Node.Pred = NULL;
	pNodePARENT->Node.Type = TYPE_PARENT;
	pNodePARENT->Node.pName = malloc (NAME_SIZE);
	strcpy (pNodePARENT->Node.pName, PARENT);
	pList->Head = (struct TNode *) pNodePARENT;

	pNode = &(pNodePARENT->Node);
	break;

      case TAG_DONE:
	lseek (CONFileHandle, 3, SEEK_CUR);
	if (pList->Pred == NULL)
	  return (pList);
	pList = pList->Pred;
	pNode = pList->Head;
	while (pNode->Succ != NULL)
	  pNode = pNode->Succ;
	break;

      default:
/* Should report error and freem all allocated memory */
	break;
    }
  }
}

/****************************************************************************/

void Introduction (void)
{
  /* Read background ASC file and draw menu
     Read window ASC file in an allocated memory area
     Read about ASC file in an allocated memory area*/

  int Handle;
  WORD *pBuffer, S;
  BYTE C, Cmd[255];
  WORD __huge *pScreen;

  /* Video setup */

  _setvideomoderows (_TEXTC80, SCREEN25_DY);
  HideCursor ();
  BlinkOff ();

  /* Read warning file and display it */

  Handle = _open (WARNINGFileName, _O_RDONLY);
  pBuffer = malloc ((SCREEN_DX*SCREEN25_DY) << 1);
  lseek (Handle, 8, SEEK_SET);
  read (Handle, pBuffer, (SCREEN_DX*SCREEN25_DY) << 1);
  pScreen = 0xB8000000;
  for (S = (SCREEN_DX*SCREEN25_DY) << 1; S != 0; S --)
    *pScreen ++ = *pBuffer ++;
  free (pBuffer);
  close (Handle);
  C = _getch ();
  while ((C != KEY_RETURN) && (C != KEY_ESC))
    _getch ();
  _clearscreen (_GCLEARSCREEN);

  /* Diplay intro picture */

  strcpy (Cmd, PICEM);
  strcat (Cmd, INTROFileName);
  system (Cmd);

  /* Video setup */

  _setvideomoderows (_TEXTC80, SCREEN50_DY);
  HideCursor ();
  BlinkOff ();

  /* Read background file and display it */

  Handle = _open (BCKFileName, _O_RDONLY);
  pBuffer = malloc ((SCREEN_DX*SCREEN50_DY) << 1);
  lseek (Handle, 8, SEEK_SET);
  read (Handle, pBuffer, (SCREEN_DX*(SCREEN50_DY-1)) << 1);
  pScreen = 0xB8000000+(SCREEN_DX << 1);
  for (S = (SCREEN_DX*(SCREEN50_DY-1)) << 1; S != 0; S --)
    *pScreen ++ = *pBuffer ++;
  free (pBuffer);
  close (Handle);

  /* Allocate memory and read window file */

  Handle = _open (WINFileName, _O_RDONLY);
  pWINData = malloc ((LDES_DX*LDES_DY) << 1);
  lseek (Handle, 8, SEEK_SET);
  read (Handle, pWINData, (LDES_DX*LDES_DY) << 1);
  close (Handle);

  /* Allocate memory and read window file */

  Handle = _open (ABOUTFileName, _O_RDONLY);
  pABOUTData = malloc ((ABOUT_DX*ABOUT_DY) << 1);
  lseek (Handle, 8, SEEK_SET);
  read (Handle, pABOUTData, (ABOUT_DX*ABOUT_DY) << 1);
  close (Handle);

  return;
}

/****************************************************************************/

struct TNode *DestroyNodePICTURE (struct TNodePICTURE *pNodePICTURE)
{
  struct TNode *pNode;

  free (pNodePICTURE->Node.pName);
  free (pNodePICTURE->pFileName);
  pNode = pNodePICTURE->Node.Succ;
  free (pNodePICTURE);

  return (pNode);
}

/****************************************************************************/

struct TNode *DestroyNodeNODE (struct TNodeNODE *pNodeNODE)
{
  struct TNode *pNode;

  free (pNodeNODE->Node.pName);
  pNode = pNodeNODE->Node.Succ;
  free (pNodeNODE);

  return (pNode);
}

/****************************************************************************/

struct TNode *DestroyNodeLIST (struct TNodeLIST *pNodeLIST)
{
  struct TNode *pNode;

  free (pNodeLIST->Node.pName);
  pNode = pNodeLIST->Node.Succ;
  free (pNodeLIST);

  return (pNode);
}

/****************************************************************************/

struct TNode *DestroyNodePARENT (struct TNodePARENT *pNodePARENT)
{
  struct TNode *pNode;

  free (pNodePARENT->Node.pName);
  pNode = pNodePARENT->Node.Succ;
  free (pNodePARENT);

  return (pNode);
}

/****************************************************************************/

void DestroyList (struct TList *pList)
{
  /* Recusive function destroying all nodes and TList structure found in
     the walk of the provided TList structure */

  struct TNode *pNode;

  pNode = pList->Head;
  while (pNode != NULL)
  {
    switch (pNode->Type)
    {
      case TYPE_PICTURE:
	pNode = DestroyNodePICTURE ((struct TNodePICTURE *) pNode);
	break;

      case TYPE_NODE:
	pNode = DestroyNodeNODE ((struct TNodeNODE *) pNode);
	break;

      case TYPE_PARENT:
	pNode = DestroyNodePARENT ((struct TNodePARENT *) pNode);
	break;

      case TYPE_LIST:
	DestroyList (((struct TNodeLIST *) pNode)->pList);
	pNode = DestroyNodeLIST ((struct TNodeLIST *) pNode);
	break;
    }
  }
  free (pList);

  return;
}

/****************************************************************************/

void DrawList (struct TNode *pNode)
{
  /* Clear and refresh list content using the list of node starting from
     the provided TNode parameter */

  BYTE Y;

  for (Y = LV_Y; Y != LV_Y + LV_DY; Y ++)
  {
    if (pNode != NULL)
    {
      WriteBlockText (pNode->pName, LV_X + 1, Y, LV_DX - 2, 1, COL_LV, CHR_LV);
      pNode = pNode->Succ;
    }
    else
      WriteBlockText (NULL, LV_X + 1, Y, LV_DX - 2, 1, COL_LV, CHR_LV);
  }

  return;
}

/****************************************************************************/

void DrawSelect (struct TNode *pNode, WORD Select, struct TNode *pOldNode, WORD OldSelect)
{
  /* Make visual selection of entry pNode, index Select in the listview
     Display short description related to pNode
     Make visual deselection of entry pOldNode, index OldSelect in the
     listview.
     It is possible to call DrawSelect (NULL, 0, pNode, ?) or
     DrawSelect (pNode, 0, pNode, ?) to perform just a selection or just
     a deselection */


  /* Unselect */

  if (pOldNode != NULL)
  {
    WriteBlockText (NULL, LV_X, LV_Y + OldSelect, 1, 1, COL_LV, CHR_LV);
    WriteBlockText (NULL, LV_X + LV_DX - 1, LV_Y + OldSelect, 1, 1, COL_LV, CHR_LV);
    WriteBlockText (pOldNode->pName, LV_X + 1, LV_Y + OldSelect, LV_DX - 2, 1, COL_LV, CHR_LV);
  }

  /* Select */

  if (pNode != NULL)
  {
    WriteBlockText (NULL, LV_X, LV_Y + Select, 1, 1, COL_LVSEL, CHR_LVSEL);
    WriteBlockText (NULL, LV_X + LV_DX - 1, LV_Y + Select, 1, 1, COL_LVSEL, CHR_LVSEL);
    WriteBlockText (pNode->pName, LV_X + 1, LV_Y + Select, LV_DX - 2, 1, COL_LVSEL, CHR_LVSEL);

    /* Display short description if any (always clear old short description) */

    switch (pNode->Type)
    {
      case TYPE_PICTURE:
	if (((struct TNodePICTURE *) pNode)->OfsSDes != - 1)
	  WriteBlockFile (CONFileHandle, ((struct TNodePICTURE *) pNode)->OfsSDes, '<', SDES_X, SDES_Y, SDES_DX, SDES_DY, COL_SDES, CHR_SDES);
	else
	  WriteBlockText (NULL, SDES_X, SDES_Y, SDES_DX, SDES_DY, COL_SDES, CHR_SDES);
	break;

      case TYPE_NODE:
	if (((struct TNodeNODE *) pNode)->OfsSDes != - 1)
	  WriteBlockFile (CONFileHandle, ((struct TNodeNODE *) pNode)->OfsSDes, '<', SDES_X, SDES_Y, SDES_DX, SDES_DY, COL_SDES, CHR_SDES);
	else
	  WriteBlockText (NULL, SDES_X, SDES_Y, SDES_DX, SDES_DY, COL_SDES, CHR_SDES);
	break;

      case TYPE_LIST:
	if (((struct TNodeLIST *) pNode)->OfsSDes != - 1)
	  WriteBlockFile (CONFileHandle, ((struct TNodeLIST *) pNode)->OfsSDes, '<', SDES_X, SDES_Y, SDES_DX, SDES_DY, COL_SDES, CHR_SDES);
	else
	  WriteBlockText (NULL, SDES_X, SDES_Y, SDES_DX, SDES_DY, COL_SDES, CHR_SDES);
	break;

      default:
	WriteBlockText (NULL, SDES_X, SDES_Y, SDES_DX, SDES_DY, COL_SDES, CHR_SDES);
    }
  }

  return;
}

/****************************************************************************/

WORD *GetImage (WORD X, WORD Y, WORD DX, WORD DY)
{
  /* Allocate a buffer and save image into it */

  WORD *pData, *pDataTmp;
  WORD __huge *pScreen;

  pData = malloc (DX*DY << 1);
  pDataTmp = pData;
  pScreen = 0xB8000000 + ((Y*SCREEN_DX + X) << 1);
  while (DY != 0)
  {
    for (X = DX; X != 0; X --)
      *pDataTmp ++ = *pScreen ++;
    pScreen += SCREEN_DX - DX;
    DY --;
  }

  return (pData);
}

/****************************************************************************/

void PutImage (WORD X, WORD Y, WORD DX, WORD DY, WORD *pData)
{
  /* Draw image and free buffer */

  WORD *pDataTmp;
  WORD __huge *pScreen;

  pDataTmp = pData;
  pScreen = 0xB8000000 + ((Y*SCREEN_DX + X) << 1);
  while (DY != 0)
  {
    for (X = DX; X != 0; X --)
      *pScreen ++ = *pDataTmp ++;

    pScreen += SCREEN_DX - DX;
    DY --;
  }
  free (pData);

  return;
}

/****************************************************************************/

void DrawLDes (struct TNode *pNode)
{
  /* Display long description of entry pNode, if any */

  WORD __huge *pScreen;
  WORD *pData, *pBuffer, X, Y;
  BYTE C;

  switch (pNode->Type)
  {
    case TYPE_LIST:
      if (((struct TNodeLIST *) pNode)->OfsLDes != -1)
      {
	pBuffer = GetImage (LDES_X, LDES_Y, LDES_DX, LDES_DY);
	pScreen = 0xB8000000 + ((SCREEN_DX*LDES_Y + LDES_X) << 1);
	pData = pWINData;
	for (Y = LDES_DY; Y != 0; Y --)
	{
	  for (X = LDES_DX; X != 0; X --)
	  {
	    *pScreen ++ = *pData ++;
	  }
	  pScreen += SCREEN_DX - LDES_DX;
	}
	WriteBlockFile (CONFileHandle, ((struct TNodeLIST *) pNode)->OfsLDes, '<', LDES_X + 1, LDES_Y + 2, LDES_DX - 3, LDES_DY - 5, COL_LDES, CHR_LDES);

	while ((C = _getch ()) != KEY_RETURN)
	  ;
	PutImage (LDES_X, LDES_Y, LDES_DX, LDES_DY, pBuffer);
      }
      break;

    case TYPE_NODE:
      if (((struct TNodeNODE *) pNode)->OfsLDes != -1)
      {
	pBuffer = GetImage (LDES_X, LDES_Y, LDES_DX, LDES_DY);
	pScreen = 0xB8000000 + ((SCREEN_DX*LDES_Y + LDES_X) << 1);
	pData = pWINData;
	for (Y = LDES_DY; Y != 0; Y --)
	{
	  for (X = LDES_DX; X != 0; X --)
	  {
	    *pScreen ++ = *pData ++;
	  }
	  pScreen += SCREEN_DX - LDES_DX;
	}
	WriteBlockFile (CONFileHandle, ((struct TNodeNODE *) pNode)->OfsLDes, '<', LDES_X + 1, LDES_Y + 2, LDES_DX - 3, LDES_DY - 5, COL_LDES, CHR_LDES);

	while ((C = _getch ()) != KEY_RETURN)
	  ;
	PutImage (LDES_X, LDES_Y, LDES_DX, LDES_DY, pBuffer);
      }
      break;

    default:
      break;
  }

  return;
}

/****************************************************************************/

void About ()
{
  /* Display About requester */

  WORD __huge *pScreen;
  WORD *pData, *pBuffer, X, Y;
  BYTE C;

  pBuffer = GetImage (ABOUT_X, ABOUT_Y, ABOUT_DX, ABOUT_DY);
  pScreen = 0xB8000000 + ((SCREEN_DX*ABOUT_Y + ABOUT_X) << 1);
  pData = pABOUTData;
  for (Y = ABOUT_DY; Y != 0; Y --)
  {
    for (X = ABOUT_DX; X != 0; X --)
    {
      *pScreen ++ = *pData ++;
    }
    pScreen += SCREEN_DX - ABOUT_DX;
  }
  while ((C = _getch ()) != KEY_RETURN)
    ;
  PutImage (ABOUT_X, ABOUT_Y, ABOUT_DX, ABOUT_DY, pBuffer);

  return;
}

/****************************************************************************/

void Quit (struct TList *pList)
{
  free (pWINData);
  free (pABOUTData);
  while (pList->Pred != NULL)
    pList = pList->Pred;
  DestroyList (pList);
  close (CONFileHandle);
  _setvideomode (_DEFAULTMODE);
  _clearscreen (_GCLEARSCREEN);
  BlinkOn ();
  ShowCursor ();
}

/****************************************************************************/

void Execute (struct TNode *pNode, struct TList *pList)
{
  /* Read commands if any and build a list of commands. Execute them */

  struct TCmdsList *pCmdsList, *pCmdsListTmp;
  BYTE I, C, MainCmd[COMMAND_SIZE];
  BYTE *Args[MAX_ARGS + 1], *pString;
  WORD __huge *pScreen, X;

  switch (pNode->Type)
  {
    case TYPE_PICTURE:
      if (((struct TNodePICTURE *) pNode)->pFileName != NULL)
      {
	strcpy (MainCmd, PICEM);
	strcat (MainCmd, ((struct TNodePICTURE *) pNode)->pFileName);
	system (MainCmd);
	HideCursor ();
	BlinkOff ();
	pScreen = 0xB8000000;
	for (X = SCREEN_DX; X > 0; X --)
	  *pScreen ++ = 0x00DB;
      }
      break;

    case TYPE_NODE:
      /* Build list of commands */

      if (((struct TNodeNODE *) pNode)->OfsCMDS == - 1)
	return;
      lseek (CONFileHandle, ((struct TNodeNODE *) pNode)->OfsCMDS, SEEK_SET);
      pCmdsList = NULL;
      for (;;)
      {
	if (pCmdsList == NULL)
	{
	  pCmdsList = malloc (sizeof (struct TCmdsList));
	  pCmdsList->Succ = NULL;
	  pCmdsList->pCommand = malloc (COMMAND_SIZE);
	  pCmdsListTmp = pCmdsList;
	}
	else
	{
	  pCmdsListTmp->Succ = malloc (sizeof (struct TCmdsList));
	  pCmdsListTmp = pCmdsListTmp->Succ;
	  pCmdsListTmp->Succ = NULL;
	  pCmdsListTmp->pCommand = malloc (COMMAND_SIZE);
	}

	pString = pCmdsListTmp->pCommand;
	do
	  read (CONFileHandle, pString, 1);
	while (*pString ++ != '\n');
	*(pString - 1) = '\0';
	read (CONFileHandle, &C, 1);
	if (C == '<')
	  break;
	else
	  lseek (CONFileHandle, - 1, SEEK_CUR);
      }

      /* Execute commands */

      if (pCmdsList != NULL)
      {
	Quit (pList);

	/* Execute all but last command */

	while (pCmdsList->Succ != NULL)
	{
	  system (pCmdsList->pCommand);
	  pCmdsListTmp = pCmdsList;
	  pCmdsList = pCmdsList->Succ;
	  free (pCmdsListTmp->pCommand);
	  free (pCmdsListTmp);
	}

	/* Execute last command */

	strcpy (MainCmd, pCmdsList->pCommand);
	free (pCmdsList->pCommand);
	free (pCmdsList);
	pString = MainCmd;
	for (I = 0; I < MAX_ARGS; I ++)
	{
	  Args[I] = pString;
	  while ((*pString != ' ') && (*pString != '\0'))
	pString ++;
	  if (*pString == '\0')
	break;
	  else
	*pString ++ = '\0';
	}
	Args[I + 1] = NULL;
	_execv (Args[0], Args);
      }
      break;

    default:
      return;
  }

  return;
}

/****************************************************************************/

BOOL CheckArgs ()
{
  /* Checks the arguments of the command line:
     - Test if <Warning> is an ASC SCREEN_DX*SCREEN50_DY/2 file
     - Test if <Background> is an ASC SCREEN_DX*SCREEN50_DY file
     - Test if <Window> is an ASC LDES_DX*LDES_DY file
     - Test if <About> is an ASC ABOUT_DX*ABOUT_DY file */

  int Handle;
  long L;
  WORD W;

  /* Check <Warning> */

  Handle = _open (WARNINGFileName, _O_RDONLY);
  if (Handle == - 1)
  {
    printf ("Can't open file \"%s\" !\n", WARNINGFileName);
    return (FALSE);
  }
  read (Handle, &L, 4);
  if (L != 0x00435341)
  {
    printf ("File \"%s\" is not an ASC file !\n", WARNINGFileName);
    close (Handle);
    return (FALSE);
  }
  read (Handle, &W, 2);
  if (W != SCREEN_DX)
  {
    printf ("Picture in file \"%s\" is not %d chars wide !\n", WARNINGFileName, SCREEN_DX);
    close (Handle);
    return (FALSE);
  }
  read (Handle, &W, 2);
  if (W != SCREEN50_DY >> 1)
  {
    printf ("Picture in file \"%s\" is not %d chars high !\n", WARNINGFileName, SCREEN50_DY >> 1);
    close (Handle);
    return (FALSE);
  }
  close (Handle);

  /* Check <background ASC file> */

  Handle = _open (BCKFileName, _O_RDONLY);
  if (Handle == - 1)
  {
    printf ("Can't open file \"%s\" !\n", BCKFileName);
    return (FALSE);
  }
  read (Handle, &L, 4);
  if (L != 0x00435341)
  {
    printf ("File \"%s\" is not an ASC file !\n", BCKFileName);
    close (Handle);
    return (FALSE);
  }
  read (Handle, &W, 2);
  if (W != SCREEN_DX)
  {
    printf ("Picture in file \"%s\" is not %d chars wide !\n", BCKFileName, SCREEN_DX);
    close (Handle);
    return (FALSE);
  }
  read (Handle, &W, 2);
  if (W != SCREEN50_DY - 1)
  {
    printf ("Picture in file \"%s\" is not %d chars high !\n", BCKFileName, SCREEN50_DY);
    close (Handle);
    return (FALSE);
  }
  close (Handle);

  /* Check <window ASC file> */

  Handle = _open (WINFileName, _O_RDONLY);
  if (Handle == - 1)
  {
    printf ("Can't open file \"%s\" !\n", WINFileName);
    return (FALSE);
  }
  read (Handle, &L, 4);
  if (L != 0x00435341)
  {
    printf ("File \"%s\" is not an ASC file !\n", WINFileName);
    close (Handle);
    return (FALSE);
  }
  read (Handle, &W, 2);
  if (W != LDES_DX)
  {
    printf ("Picture in file \"%s\" is not %d chars wide !\n", WINFileName, LDES_DX);
    close (Handle);
    return (FALSE);
  }
  read (Handle, &W, 2);
  if (W != LDES_DY)
  {
    printf ("Picture in file \"%s\" is not %d chars high !\n", WINFileName, LDES_DY);
    close (Handle);
    return (FALSE);
  }
  close (Handle);

  /* Check <about ASC file> */

  Handle = _open (ABOUTFileName, _O_RDONLY);
  if (Handle == - 1)
  {
    printf ("Can't open file \"%s\" !\n", ABOUTFileName);
    return (FALSE);
  }
  read (Handle, &L, 4);
  if (L != 0x00435341)
  {
    printf ("File \"%s\" is not an ASC file !\n", ABOUTFileName);
    close (Handle);
    return (FALSE);
  }
  read (Handle, &W, 2);
  if (W != ABOUT_DX)
  {
    printf ("Picture in file \"%s\" is not %d chars wide !\n", ABOUTFileName, ABOUT_DX);
    close (Handle);
    return (FALSE);
  }
  read (Handle, &W, 2);
  if (W != ABOUT_DY)
  {
    printf ("Picture in file \"%s\" is not %d chars high !\n", ABOUTFileName, ABOUT_DY);
    close (Handle);
    return (FALSE);
  }
  close (Handle);

  return (TRUE);
}

/****************************************************************************/

main (int argc, char *argv[], char *envp[])
{
  BYTE Key, *pString;
  struct TList *pList;
  struct TNode *pNode, *pNodeTmp;
  WORD X, W, Select;
  BYTE Path[PATH_SIZE];

  /* Control args */

  _clearscreen (_GCLEARSCREEN);
  if (argc != 7)
  {
    printf ("Syntax: MPC <Configuration> <Intro> <Warning> <Background> <Window> <About>\n");
    return (0);
  }
  strcpy (CONFileName, argv[1]);
  strcpy (INTROFileName, argv[2]);
  strcpy (WARNINGFileName, argv[3]);
  strcpy (BCKFileName, argv[4]);
  strcpy (WINFileName, argv[5]);
  strcpy (ABOUTFileName, argv[6]);
  if (CheckArgs () == FALSE)
  {
    printf ("Syntax: MPC <Configuration> <Intro> <Warning> <Background> <Window> <About>\n");
    return (0);
  }

  /* Initializations */

  _chdir ("\\");
  pList = CONSetup ();
  Select = 0;
  pNode = pList->Head;
  Introduction ();
  DrawList (pNode);
  DrawSelect (pNode, Select, NULL, 0);
  Path[0] = '\0';
  WriteBlockText (Path, PATH_X, PATH_Y, PATH_DX, PATH_DY, COL_PATH, CHR_PATH);

  /* Main loop */

  for (;;)
  {
    Key = _getch ();
    switch (Key)
    {
      case KEY_RETURN:
	switch (pNode->Type)
	{
	  case TYPE_NODE:
	  case TYPE_PICTURE:
	    Execute (pNode, pList);
	    break;

	  case TYPE_PARENT:
	    DrawSelect (NULL, 0, pNode, Select);
	    pList = pList->Pred;
	    pNode = pList->Head;
	    Select = 0;
	    DrawList (pNode);
	    DrawSelect (pNode, Select, NULL, 0);
	    pString = Path + strlen (Path);
	    while (*pString != '\\')
	      pString --;
	    *pString = '\0';
	    WriteBlockText (Path, PATH_X, PATH_Y, PATH_DX, PATH_DY, COL_PATH, CHR_PATH);
	    break;

	  case TYPE_LIST:
	    pString = Path;
	    while (*pString != '\0')
	      pString ++;
	    W = PATH_SIZE - (pString + 1 - Path);
	    if (W != 0)
	    {
	      *pString ++ = '\\';
	      *pString = '\0';
	      if (W -- != 0)
	      {
		strncpy (pString, pNode->pName, W);
		*(pString + W) = '\0';
	      }
	    }
	    WriteBlockText (Path, PATH_X, PATH_Y, PATH_DX, PATH_DY, COL_PATH, CHR_PATH);
	    DrawSelect (NULL, 0, pNode, Select);
	    pList = ((struct TNodeLIST *) pNode)->pList;
	    pNode = pList->Head;
	    Select = 0;
	    DrawList (pNode);
	    DrawSelect (pNode, Select, NULL, 0);
	    break;

	  default:
	    break;
	}
	break;

      case KEY_e:
      case KEY_E:
	Execute (pNode, pList);
	break;

      case KEY_a:
      case KEY_A:
	About ();
	break;

      case KEY_d:
      case KEY_D:
	DrawLDes (pNode);
	break;

      case KEY_q:
      case KEY_Q:
      case KEY_ESC:
	Quit (pList);
	return (0);

      case 0:
	Key = _getch ();
	switch (Key)
	{
	  case KEY_PUP:
	    pNodeTmp = pNode;
	    for (X = Select; X != 0; X --)
	      pNodeTmp = pNodeTmp->Pred;
	    X = 0;
	    while (pNodeTmp->Pred != NULL)
	    {
	      pNodeTmp = pNodeTmp->Pred;
	      X ++;
	      if (X == LV_DY)
		break;
	    }
	    if (X != 0)
	    {
	      DrawSelect (NULL, 0, pNode, Select);
	      pNode = pNodeTmp;
	      Select = 0;
	      DrawList (pNode);
	      DrawSelect (pNode, Select, NULL, 0);
	    }
	    else if (Select != 0)
	    {
	      DrawSelect (pNodeTmp, 0, pNode, Select);
	      pNode = pNodeTmp;
	      Select = 0;
	    }
	    break;

	  case KEY_PDOWN:
	    if (pNode->Succ != NULL)
	    {
	      pNodeTmp = pNode;
	      for (X = LV_DY - Select; X != 0; X --)
	      {
		if (pNodeTmp->Succ == NULL)
		{
		  DrawSelect (pNodeTmp, LV_DY - X, pNode, Select);
		  pNode = pNodeTmp;
		  Select = LV_DY - X;
		  break;
		}
		pNodeTmp = pNodeTmp->Succ;
	      }
	      if (X == 0)
	      {
		DrawSelect (NULL, 0, pNode, Select);
		pNode = pNodeTmp;
		Select = 0;
		DrawList (pNode);
		DrawSelect (pNode, Select, NULL, 0);
	      }
	    }
	    break;

	  case KEY_UP:
	    if (Select != 0)
	    {
	      DrawSelect (pNode->Pred, Select - 1, pNode, Select);
	      Select --;
	      pNode = pNode->Pred;
	    }
	    else
	    {
	      if (pNode->Pred != NULL)
	      {
		pNode = pNode->Pred;
		DrawList (pNode);
		DrawSelect (pNode, Select, NULL, 0);
	      }
	    }
	    break;

	  case KEY_DOWN:
	    if (Select != (LV_DY - 1))
	    {
	      if (pNode->Succ != NULL)
	      {
		DrawSelect (pNode->Succ, Select + 1, pNode, Select);
		Select ++;
		pNode = pNode->Succ;
	      }
	    }
	    else
	    {
	      if (pNode->Succ != NULL)
	      {
		for (W = LV_DY - 2; W != 0; W --)
		  pNode = pNode->Pred;
		DrawList (pNode);
		for (W = LV_DY - 1; W != 0; W --)
		  pNode = pNode->Succ;
		DrawSelect (pNode, Select, NULL, 0);
	      }
	    }
	    break;

	  default:
	    break;
	}
	break;

      default:
	break;
    }
  }
}
